package com.hai.dao;

import com.hai.entity.HighActivityPrize;
import com.hai.entity.HighActivityPrizeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighActivityPrizeMapper extends HighActivityPrizeMapperExt {
    @SelectProvider(type=HighActivityPrizeSqlProvider.class, method="countByExample")
    long countByExample(HighActivityPrizeExample example);

    @DeleteProvider(type=HighActivityPrizeSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighActivityPrizeExample example);

    @Delete({
        "delete from high_activity_prize",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_activity_prize (activity_award_id, prize_type, ",
        "prize_id, prize_img, ",
        "prize_name, prize_num, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{activityAwardId,jdbcType=BIGINT}, #{prizeType,jdbcType=INTEGER}, ",
        "#{prizeId,jdbcType=BIGINT}, #{prizeImg,jdbcType=VARCHAR}, ",
        "#{prizeName,jdbcType=VARCHAR}, #{prizeNum,jdbcType=INTEGER}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighActivityPrize record);

    @InsertProvider(type=HighActivityPrizeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighActivityPrize record);

    @SelectProvider(type=HighActivityPrizeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_award_id", property="activityAwardId", jdbcType=JdbcType.BIGINT),
        @Result(column="prize_type", property="prizeType", jdbcType=JdbcType.INTEGER),
        @Result(column="prize_id", property="prizeId", jdbcType=JdbcType.BIGINT),
        @Result(column="prize_img", property="prizeImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="prize_name", property="prizeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="prize_num", property="prizeNum", jdbcType=JdbcType.INTEGER),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighActivityPrize> selectByExample(HighActivityPrizeExample example);

    @Select({
        "select",
        "id, activity_award_id, prize_type, prize_id, prize_img, prize_name, prize_num, ",
        "`status`, create_time, update_time, ext_1, ext_2, ext_3",
        "from high_activity_prize",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_award_id", property="activityAwardId", jdbcType=JdbcType.BIGINT),
        @Result(column="prize_type", property="prizeType", jdbcType=JdbcType.INTEGER),
        @Result(column="prize_id", property="prizeId", jdbcType=JdbcType.BIGINT),
        @Result(column="prize_img", property="prizeImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="prize_name", property="prizeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="prize_num", property="prizeNum", jdbcType=JdbcType.INTEGER),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighActivityPrize selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighActivityPrizeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighActivityPrize record, @Param("example") HighActivityPrizeExample example);

    @UpdateProvider(type=HighActivityPrizeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighActivityPrize record, @Param("example") HighActivityPrizeExample example);

    @UpdateProvider(type=HighActivityPrizeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighActivityPrize record);

    @Update({
        "update high_activity_prize",
        "set activity_award_id = #{activityAwardId,jdbcType=BIGINT},",
          "prize_type = #{prizeType,jdbcType=INTEGER},",
          "prize_id = #{prizeId,jdbcType=BIGINT},",
          "prize_img = #{prizeImg,jdbcType=VARCHAR},",
          "prize_name = #{prizeName,jdbcType=VARCHAR},",
          "prize_num = #{prizeNum,jdbcType=INTEGER},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighActivityPrize record);
}