package com.hai.dao;

import com.hai.entity.HighCouponAgentRel;
import com.hai.entity.HighCouponAgentRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighCouponAgentRelMapper extends HighCouponAgentRelMapperExt {
    @SelectProvider(type=HighCouponAgentRelSqlProvider.class, method="countByExample")
    long countByExample(HighCouponAgentRelExample example);

    @DeleteProvider(type=HighCouponAgentRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighCouponAgentRelExample example);

    @Delete({
        "delete from high_coupon_agent_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_coupon_agent_rel (parent_coupon_agent_id, `type`, ",
        "coupon_name, sales_price, ",
        "coupon_id, agent_id, ",
        "stock_count, sales_count, ",
        "create_time, `status`, ",
        "operator_id, operator_name, ",
        "ext_1, ext_2, ext_3)",
        "values (#{parentCouponAgentId,jdbcType=BIGINT}, #{type,jdbcType=INTEGER}, ",
        "#{couponName,jdbcType=VARCHAR}, #{salesPrice,jdbcType=DECIMAL}, ",
        "#{couponId,jdbcType=BIGINT}, #{agentId,jdbcType=BIGINT}, ",
        "#{stockCount,jdbcType=INTEGER}, #{salesCount,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{operatorId,jdbcType=BIGINT}, #{operatorName,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighCouponAgentRel record);

    @InsertProvider(type=HighCouponAgentRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighCouponAgentRel record);

    @SelectProvider(type=HighCouponAgentRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="parent_coupon_agent_id", property="parentCouponAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="coupon_name", property="couponName", jdbcType=JdbcType.VARCHAR),
        @Result(column="sales_price", property="salesPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="coupon_id", property="couponId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="stock_count", property="stockCount", jdbcType=JdbcType.INTEGER),
        @Result(column="sales_count", property="salesCount", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighCouponAgentRel> selectByExample(HighCouponAgentRelExample example);

    @Select({
        "select",
        "id, parent_coupon_agent_id, `type`, coupon_name, sales_price, coupon_id, agent_id, ",
        "stock_count, sales_count, create_time, `status`, operator_id, operator_name, ",
        "ext_1, ext_2, ext_3",
        "from high_coupon_agent_rel",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="parent_coupon_agent_id", property="parentCouponAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="coupon_name", property="couponName", jdbcType=JdbcType.VARCHAR),
        @Result(column="sales_price", property="salesPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="coupon_id", property="couponId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="stock_count", property="stockCount", jdbcType=JdbcType.INTEGER),
        @Result(column="sales_count", property="salesCount", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighCouponAgentRel selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighCouponAgentRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighCouponAgentRel record, @Param("example") HighCouponAgentRelExample example);

    @UpdateProvider(type=HighCouponAgentRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighCouponAgentRel record, @Param("example") HighCouponAgentRelExample example);

    @UpdateProvider(type=HighCouponAgentRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighCouponAgentRel record);

    @Update({
        "update high_coupon_agent_rel",
        "set parent_coupon_agent_id = #{parentCouponAgentId,jdbcType=BIGINT},",
          "`type` = #{type,jdbcType=INTEGER},",
          "coupon_name = #{couponName,jdbcType=VARCHAR},",
          "sales_price = #{salesPrice,jdbcType=DECIMAL},",
          "coupon_id = #{couponId,jdbcType=BIGINT},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "stock_count = #{stockCount,jdbcType=INTEGER},",
          "sales_count = #{salesCount,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighCouponAgentRel record);
}